From 2b79f4b88ee5fb8c018c8baa3fea0db9bf893ed3 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 13 2017 11:29:37 +0000
Subject: [PATCH 748/1001] Move validators to the widgets module


Validators are actually only used by widgets, it makes more sense to
have them with the other widget-related modules.

---

diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index 5fe313c..1de5e0c 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -1,9 +1,8 @@
 from __future__ import unicode_literals
 
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
-from hubs import validators
-
 
 class About(Widget):
 
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index 1c102cb..c609776 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import operator
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index 5717e24..99d02f1 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import requests
 import pkgwat.api
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index daa0600..463e359 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index 4887af8..0b68bcb 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -5,8 +5,8 @@ import fedmsg.config
 import fedmsg.meta
 import requests
 
-from hubs import validators
 from hubs.utils import commas
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index 9180637..30b39eb 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -1,7 +1,7 @@
 from __future__ import unicode_literals
 
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 import logging
diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
index 49a7955..7b83881 100644
--- a/hubs/widgets/fhosted/__init__.py
+++ b/hubs/widgets/fhosted/__init__.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 from six.moves.xmlrpc_client import ServerProxy
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index d794c24..1d41502 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import logging
 import hubs.utils
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index 7172dbb..39d5aa0 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index bab0ab4..e1d4511 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -1,7 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
-from hubs.widgets import clean_input
+from hubs.widgets import clean_input, validators
 from hubs.widgets.base import Widget, WidgetView
 
 
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index 0da1cb7..e9765ca 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index fbe712a..568a04b 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -5,8 +5,8 @@ import collections
 import datetime
 import requests
 
-from hubs import validators
 from hubs import utils
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index 1ace710..48c57a0 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index f8df811..7aa36c7 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
index 5c207a3..1ec9c09 100644
--- a/hubs/widgets/rules/__init__.py
+++ b/hubs/widgets/rules/__init__.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 from collections import OrderedDict as ordereddict
 
-from hubs import validators
 from hubs.utils import username2avatar
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 3fcccfc..baec759 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
 
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index b427ad5..d6dd928 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals
 import flask
 import hubs.models
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
new file mode 100644
index 0000000..b59ca25
--- /dev/null
+++ b/hubs/widgets/validators.py
@@ -0,0 +1,106 @@
+from __future__ import unicode_literals
+
+import kitchen.text.converters
+
+import hubs.models
+import requests
+
+
+class Validator(object):
+
+    @classmethod
+    def from_string(cls, value):
+        if value is None:
+            return ""
+        return value
+
+    @classmethod
+    def to_string(cls, value):
+        return value
+
+
+class Required(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        if not bool(value):
+            raise ValueError("the parameter is required")
+        return value
+
+
+class Text(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        return kitchen.text.converters.to_unicode(value)
+
+
+class Integer(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        return int(value)
+
+
+class Link(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- verify that this is actually a link
+        return value
+
+
+class Username(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        if hubs.models.User.by_username(value) is not None:
+            return value
+        raise ValueError('Invalid username')
+
+
+class GithubOrganization(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- implement this.
+        return value
+
+
+class GithubRepo(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- implement this.
+        return value
+
+
+class FMNContext(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO get this from the fedmsg config.
+        if value in [
+            'irc', 'email', 'android', 'desktop', 'hubs',]:
+            return value
+        raise ValueError('Invalid FMN context')
+
+
+class PagureRepo(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        response = requests.get("https://pagure.io/%s" % value, timeout=5)
+        if response.status_code == 200:
+            return value
+        raise ValueError('Invalid pagure repo')
+
+
+class FedorahostedProject(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        response = requests.get("https://fedorahosted.org/%s" % value, timeout=5)
+        if response.status_code == 200:
+            return value
+        raise ValueError('Invalid fedorahosted project')
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 1c926d5..40c19ec 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
 from hubs.utils import username2avatar
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 92a56dd..4f6f462 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -2,7 +2,7 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs import validators
+from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 

